var Est32100_EvolucaoDeCusto_Service = function(Est32100_EvolucaoDeCusto_Repository, restEngine, ZHPromise) {
    this.requestReport = function(row) {
        row.CDARVPRODFIN = row.CDARVPRODFIN + "zzzzzzzzzzzzzzzzzzz";
        row.CDARVPRODFIN = row.CDARVPRODFIN.substring(0, 20);
        if(row.REPORT_NAME != 'Est32101PercentMinimo') 
            row.PERMINIMO  = '';
            
        return Est32100_EvolucaoDeCusto_Repository.getReport(row);
    };

    this.retornaParamUnidade = function(cdFilialOpcional) {
        var cdFilialFiltrada = cdFilialOpcional || "FILIAL_LOGADA";
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": cdFilialFiltrada
            }
        ];
        return restEngine.post("est#/crud/paramfilial", {
            "requestType": "FilterData",
            "filter": filter
        });
    };

    this.requestValidations = function(cdfilial) {
        var deferred = ZHPromise.defer();

        this.retornaParamUnidade(cdfilial).then(function(response){
            if(response.dataset.paramfilial) {
                var ret = Array();
                
                deferred.resolve(ret);
            } else {
                deferred.reject({"error": {"message": "Request error."}});
            }
        });

        return deferred;
    };
};

Configuration(function(ContextRegister){
    ContextRegister.register('Est32100_EvolucaoDeCusto_Service', Est32100_EvolucaoDeCusto_Service);
});
