package com.javaseleniumtemplate.tests.AjusteIventarioTests;
import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.AjusteInventarioFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.pages.AjusteInventarioPage;
import com.javaseleniumtemplate.pages.MainPage;
import org.testng.annotations.Test;

public class EditarAjusteIventarioTests extends TestBase {
    MainPage mainPage;
    LoginFlows loginFlows;
    MainFlows mainFlows;
    AjusteInventarioFlows ajusteInventarioFlows;
    AjusteInventarioPage ajusteInventarioPage;

    @Test
    public void editarAjusteInventario(){

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        ajusteInventarioFlows = new AjusteInventarioFlows();
        ajusteInventarioPage = new AjusteInventarioPage();

        //Parameteres
        String usuario = "sandro.silva@teknisa.com";
        String senha = "Teknisa@2022";
        String quantidade = "2";
        String cmpDesc2 = "Deletar";
        String nomeOperador = "Sandro Siilva";
        //String remetente = "Todos";
        //String destinatario = "Alibra Ingredientes Ltda";
        //String serie = "SERIE 1";
        //String operacao = "NF Cobrança";
        //String modeloDocumentoFiscal = "Nota Fiscal Eletrônica";
        //String serieFormulario = "Série 142";
        //String dataSaida = "16/08/2021";
        //String nomeProduto = "Hela Poultry Broth Paste Clear KG";
        //String quantidadeProduto = "1";
        //String statusEsperado = "Pendente";

        loginFlows.efetuarLogin(usuario,senha);
        mainFlows.navegarParaAjusteInventario();
        ajusteInventarioFlows.aplicarFiltro(nomeOperador);
        ajusteInventarioFlows.editarAjusteIventario(cmpDesc2,quantidade);


        /*
        lancamentoSaidaPage.clicarAdicionarLancamento();

        //criando lancamento
        lancamentoSolicitacaoComprasPage.preencherFiltroUnidadeSolicitante(unidade);
        lancamentoSaidaPage.preencherOperacao(custo);
        lancamentoSaidaPage.preencherDocumentoFiscal(modeloDocumentoFiscal);
        lancamentoSaidaPage.clicarPesquisaDestinatario();
        lancamentoSaidaPage.preencherDestinatario(destinatario);
        lancamentoSaidaPage.clicarEscolherDestinatario();
        lancamentoSaidaPage.clicarPesquisaSerie();
        lancamentoSaidaPage.preencherSerie(serieFormulario);
        lancamentoSaidaPage.clicarEscolherSerie(serieFormulario);
        lancamentoSaidaPage.preencherDataSaida(dataSaida);
        lancamentoSaidaPage.salvarLancamento();

        //adicionando produto
        lancamentoSaidaPage.clicarMenuProdutos();
        lancamentoSaidaPage.clicarAdicionarProduto();
        lancamentoSaidaPage.clicarPesquisaProduto();
        lancamentoSaidaPage.preencherNomeProduto(nomeProduto);
        lancamentoSaidaPage.clicarEscolherProduto();
        lancamentoSaidaPage.clicarPesquisaLoteProduto();
        lancamentoSaidaPage.clicarEscolherLoteProduto();
        lancamentoSaidaPage.clicarConfirmarProduto();
        lancamentoSaidaPage.preencherQuantidadeProduto(quantidadeProduto);
        lancamentoSaidaPage.clicarSalvarProduto();

        //finalizar lancamento
        lancamentoSaidaPage.clicarFecharLancamento();
        lancamentoSaidaPage.clicarConfirmarFecharLancamento();

        String statusAtual = lancamentoSaidaPage.retornarStatusLancamento();

        Assert.assertEquals(statusAtual,statusEsperado);
        */

    }



}
